import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import plugin from "@start/plugin";
export default ((outDir, userOptions) => plugin('typescriptGenerate',
/*#__PURE__*/
function () {
  var _ref = _asyncToGenerator(function* ({
    files,
    logFile
  }) {
    const _ref2 = yield import('path'),
          path = _ref2.default;

    const _ref3 = yield import('execa'),
          execa = _ref3.default;

    const tscBinPath = path.resolve('node_modules/.bin/tsc');
    const spawnOptions = {
      stripEof: false,
      env: {
        FORCE_COLOR: '1'
      }
    };

    const options = _objectSpread({
      allowSyntheticDefaultImports: true,
      lib: 'esnext',
      moduleResolution: 'node'
    }, userOptions, {
      declarationDir: outDir,
      emitDeclarationOnly: true,
      declaration: true
    });

    const tscArgs = Object.keys(options).reduce((result, key) => {
      const value = options[key];

      if (typeof value === 'boolean') {
        return result.concat(`--${key}`);
      }

      if (typeof value === 'string') {
        return result.concat(`--${key}`, `${value}`);
      }

      if (Array.isArray(value)) {
        return result.concat(`--${key}`, `${value.join(',')}`);
      }

      return result;
    }, []);
    return Promise.all(files.map(file => execa(tscBinPath, [...tscArgs, file.path], spawnOptions).then(() => {
      const dtsFile = `${path.basename(file.path, '.ts')}.d.ts`;
      const dtsPath = path.resolve(outDir, dtsFile);
      logFile(dtsPath);
      return {
        path: dtsPath,
        data: null,
        map: null
      };
    })));
  });

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}()));